
#include <CTBot.h>
#include <AccelStepper.h>
#define IN1 19
#define IN2 18
#define IN3 5
#define IN4 17
#define MotorInterfaceType 8
const int soil = 34;
const int chy = 35;
const int hujan = 32;
AccelStepper stepper = AccelStepper(MotorInterfaceType, IN1, IN3, IN2, IN4);
CTBot mybot ;

//wifi
String ssid = "wireless@umsida.ac.id";
String pass = "AhmadDahlan1868";
String token = "5893424025:AAFhyHiKWpymMYOJjYsXhFk9EyAfyYz5HQ8";
const int id = 1649574090 ;

bool flag1 = false;
bool flag2 = false;
bool flag3 = false;

void setup() {
  Serial.begin(9600);
  stepper.setMaxSpeed(1000);
  stepper.setAcceleration(1000);
  //stepper.setMaxSpeed(1000);
  //stepper.setAcceleration(100);
  mybot.wifiConnect(ssid, pass);
  mybot.setTelegramToken(token);

  //uji koneksi
  if (mybot.testConnection())
  {
    Serial.println("Koneksi Berhasil");
  }
  else
  {
    Serial.println("Koneksi Gagal");
  }
  //stepper.runToNewPosition(2038);//2048
}

void loop() {
  int adc1 = analogRead(soil) / 16;
  Serial.println(adc1);
  int adc2 = analogRead(chy) / 16;
  Serial.println(adc2);
  int adc3 = analogRead(hujan) / 16;
  Serial.println(adc3);
  Serial.println(" ");

  if (adc3 < 150) {
    TBMessage msg ;
    if (mybot.getNewMessage (msg))
    {
      Serial.println("Pesan Masuk : " + msg.text);
      //variabel penampung isi pesan
      String pesan = msg.text;
      if (pesan == "/buka")
      {
        Serial.println("Mengirim pesan ke Telegram...");
        String reply;
        reply = (String)"kondisi hujan, atap tidak bisa dibuka";
        mybot.sendMessage(id, reply);
      }
    }
    if (flag1 == false) {
      flag3 = false;
      Serial.println("hujan");
      mybot.sendMessage(id, "kondisi hujan, atap ditutup");
      stepper.runToNewPosition(16000);
      yield();
      flag1 = true;
    }
  }
  if (adc3 >= 150) {
    flag1 = false;
    if (flag3 == false) {
      mybot.sendMessage(id, "kondisi cerah, atap terbuka");
      stepper.runToNewPosition(-16000);
      yield();
      flag3 = true;
    }
  }
  if (adc2 >= 100) {
    if (flag2 == false) {
      Serial.println("mendung");
      mybot.sendMessage(id, "kondisi mendung, atap ditutup");
      stepper.runToNewPosition(16000);
      yield();
      flag2 = true;
    }
  }
  if (adc2 < 100) {
    flag2 = false;
  }

  TBMessage msg ;
  if (mybot.getNewMessage (msg))
  {
    Serial.println("Pesan Masuk : " + msg.text);
    //variabel penampung isi pesan
    String pesan = msg.text;
    if (pesan == "/start")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"Selamat Datang Boss\n" +
              (String)"Masukkan pesan dibawah ini untuk perintah.\n" +
              (String)"/kondisi     : untuk mengetahui seluruh kondisi aviary.\n" +
              (String)"/kelembapan  : untuk mengetahui kelembapan tanah aviary.\n" +
              (String)"/cahaya      : untuk mengetahui intensitas cahaya.\n" +
              (String)"/cuaca       : untuk mengetahui cuaca.\n" +
              (String)"/buka        : untuk membuka atap aviary.\n" +
              (String)"/tutup       : untuk menutup atap aviary.";
      mybot.sendMessage(id, reply);
    }
    if (pesan == "/kondisi")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"Kondisi saat ini\n" +
              (String)"Kelembapan       : " + adc1 + (String)" \n" +
              (String)"Intensitas cahaya: " + adc2 + (String)" \n" +
              (String)"cuaca            : " + adc3;
      mybot.sendMessage(id, reply);
    }
    if (pesan == "/kelembapan")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"Kelembapan saat ini\n" +
              (String)"Kelembapan: " + adc1 + (String)" ";
      mybot.sendMessage(id, reply);
    }
    if (pesan == "/cahaya")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"intensitas cahaya saat ini\n" +
              (String)"Intensitas cahaya: " + adc2 + (String)" ";
      mybot.sendMessage(id, reply);
    }
    if (pesan == "/cuaca")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"cuaca saat ini\n" +
              (String)"cuaca: " + adc3;
      mybot.sendMessage(id, reply);
    }
    if (pesan == "/buka")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"okay atap terbuka";
      mybot.sendMessage(id, reply);
      stepper.runToNewPosition(-16000);
      yield();
    }
    if (pesan == "/tutup")
    {
      Serial.println("Mengirim pesan ke Telegram...");
      String reply;
      reply = (String)"okay atap tertutup";
      mybot.sendMessage(id, reply);
      stepper.runToNewPosition(16000);
      yield();
    }
  }
  delay(1000);
}
